// TODO : essayer de faire des parties plus grosses, et pas 5 de taille 35 / 5
// TODO : catalyser chez moi pour diminuer l'entropie

#include <bits/stdc++.h>

#include "prologin.hh"

#define FOR(i, n) for(int (i) = 0; (i) < (n); ++(i))
#define FORU(i, a, b) for(int (i) = a; (i) <= (b); ++(i))
#define FORD(i, a, b) for(int (i) = a; (i) >= (b); --(i))

#define GRILLE(i, j) FOR((i), TAILLE_ETABLI) FOR((j), TAILLE_ETABLI)
#define GRILLE2(i, j, pos) GRILLE(i, j) for(position pos = {i, j}; pos.ligne != -1; pos.ligne = -1)

#define MOI 0
#define ADV 1

using namespace std;
using lli = long long int;

const int oo = 1E9;

int dir[4][2] = {{1,0},{0,1},{-1,0},{0,-1}};

case_type met[3] = {PLOMB, FER, CUIVRE};
case_type cat[2] = {SOUFRE, MERCURE};

case_type types[5] = {PLOMB, FER, CUIVRE, SOUFRE, MERCURE};

int joueurs[2];
case_type grilles[2][TAILLE_ETABLI][TAILLE_ETABLI];
map<case_type, vector<position> > cases[2];
echantillon cur_ech;
bool dejaVu[TAILLE_ETABLI][TAILLE_ETABLI];

bool est_met(position, int);
bool est_cat(position, int);
int quantite_transmutation(position, int);
int taille(position, int);
int libertes(position, int);
int centralite(position, int);
int centralite_vide(position, int);
int isolement(position, int);
void marquer(position, int);
vector<pair<vector<position>, int> > coupes(position, int, int maxi = 2, int last = -1);

void choisir(vector<position_echantillon>&, int);

void transmute();
int transmute(position pos, bool tempo = false);

void placer();

/// Fonction appelée au début de la partie.
void partie_init()
{
    srand(time(NULL));
    joueurs[MOI] = moi();
    joueurs[ADV] = adversaire();
}

void update_grille(int id)
{
    cases[id].clear();
    GRILLE2(i, j, pos)
    {
        grilles[id][i][j] = type_case(pos, joueurs[id]);
        if(cases[id].count(grilles[id][i][j]) == 0)
            cases[id][grilles[id][i][j]] = vector<position>();
        cases[id][grilles[id][i][j]].push_back(pos);
    }
}

/// Fonction appelée à chaque tour.
void jouer_tour()
{
    FOR(i, 2)
        update_grille(i);
    cur_ech = echantillon_tour();
    placer();
    if(tour_actuel() >= NB_TOURS - 2)
    {
        GRILLE(i, j)
            if(est_cat({i, j}, MOI) && quantite_transmutation({i,j}, MOI) >= 0)
            {
                transmute({i,j});
                update_grille(MOI);
            }
        GRILLE(i, j)
            if(est_met({i, j}, MOI) && quantite_transmutation({i,j}, MOI) > 0)
            {
                transmute({i,j});
                update_grille(MOI);
            }
    }
    case_type a = cases[ADV][cur_ech.element1].size() > cases[ADV][cur_ech.element2].size() ? cur_ech.element2 : cur_ech.element1;
    case_type b = types[1] == a ? types[0] : types[1];
    for(auto t : types)
        if(t != a && cases[ADV][b].size() > cases[ADV][t].size())
            b = t;
    donner_echantillon({a, b});
}

/// Fonction appelée à la fin de la partie.
void partie_fin()
{
}

int quantite_transmutation(position pos, int id)
{
    if(est_met(pos, id))
        return quantite_transmutation_or(taille_region(pos, joueurs[id]));
    return quantite_transmutation_catalyseur_or(taille_region(pos, joueurs[id]));
}

void placer()
{
    vector<position_echantillon> coups = placements_possible_echantillon(cur_ech, joueurs[MOI]);
    if(coups.size())
    {
        choisir(coups, MOI);
        return;
    }
    vector<position> options;
    GRILLE(i, j)
        dejaVu[i][j] = 0;
    GRILLE2(i, j, pos)
        if(grilles[MOI][i][j] != VIDE && !dejaVu[i][j])
        {
            vector<position> zone = positions_region(pos, MOI);
            for(auto c : zone)
                dejaVu[c.ligne][c.colonne] = 1;
    //printf("kwak\n");
            int nbA = transmute(pos, true);
    //printf("plop\n");
            if(placements_possible_echantillon(cur_ech, joueurs[MOI]).size())
                options.push_back(pos);
    //printf("coin\n");
            FOR(k, nbA)
                annuler();
        }
    if(options.size())
    {
        bool cat_first = rand() % 2; // TODO improve this ugly fix
        auto collision = [&] (const position& a) -> bool {
            return grilles[MOI][a.ligne][a.colonne] == echantillon_tour().element1 || grilles[MOI][a.ligne][a.colonne] == echantillon_tour().element2;
        };
        auto cmp_options = [&] (const position& a, const position& b) -> bool {
            if(quantite_transmutation(a, MOI) < 1 || quantite_transmutation(b, MOI) < 1)
                return quantite_transmutation(a, MOI) > quantite_transmutation(b, MOI);
            if(collision(a) && !collision(b))
                return false;
            if(!collision(a) && collision(b))
                return true;
            if(est_cat(a, MOI) && est_met(b, MOI))
                return cat_first;
            if(est_cat(b, MOI) && est_met(a, MOI))
                return !cat_first;
            if(est_cat(a, MOI) && est_cat(b, MOI))
                return quantite_transmutation(a, MOI) > quantite_transmutation(b, MOI);
            return quantite_transmutation(a, MOI) < quantite_transmutation(b, MOI);
        };
        position best = options[0];
        for(auto p : options)
            if(cmp_options(p, best))
                best = p;
        transmute(best);
        update_grille(MOI);
    }
    while(coups.empty())
    {
        coups = placements_possible_echantillon(cur_ech, joueurs[MOI]);
        if(coups.empty())
            transmute();
        else
            placer_echantillon(coups[0].pos1, coups[0].pos2);
    }
}

int transmute(position pos, bool tempo)
{
    int nbA = 1;
    transmuter(pos);
    if(est_cat(pos, MOI) && !tempo)
    {
        int nbC = nombre_catalyseurs();
        while(nbC)
        {
            //printf("coin\n");
            GRILLE(i, j)
                dejaVu[i][j] = 0;
            vector<position> valides;
            GRILLE2(i, j, pos)
                if(!dejaVu[i][j] && est_met(pos, ADV))
                {
                    marquer(pos, MOI);
                    valides.push_back(pos);
                }
            if(valides.empty()) break;
            position best = valides[0];
            int bsum = -1;
            for(auto p : valides)
            {
                int sz = taille(p, ADV);
                if(sz > 1)
                {
                    // TODO : Debug, the cut isn't optimal
                    vector<pair<vector<position>, int> > cps = coupes(p, ADV, min(sz-1, min(2, nbC)));
                    //printf("%d %d\n", p.ligne, p.colonne);
                    //for(auto pp : cps)
                    //{
                    //    printf("%d :", pp.second);
                    //    for(auto ppp : pp.first)
                    //        printf(" (%d, %d)", ppp.ligne, ppp.colonne);
                    //    printf("\n");
                    //}
                    //assert(false);
                    if(cps.size())
                    {
                        int maxi = -1;
                        int ss = taille(p, ADV);
                        for(auto pp : cps)
                            maxi = max(maxi, (((ss * ss) / 4 - 1) - pp.second) / (int)pp.first.size());
                        if(maxi > bsum)
                        {
                            bsum = maxi;
                            best = p;
                        }
                    }
                }
            }
            if(bsum == -1)
            {
                valides.clear();
                vector<position> valides;
                GRILLE2(i, j, pos)
                    if(est_met(pos, ADV))
                        valides.push_back(pos);
                int i = rand() % valides.size();
                position pos = valides[i];
                catalyser(pos, joueurs[ADV], (case_type)((rand() % 2) + 4));
                ++nbA;
                --nbC;
            }
            else
            {
                int ss = taille(best, ADV);
                vector<pair<vector<position>, int> > cps = coupes(best, ADV, min(ss-1, min(2, nbC)));
                vector<position> coupe;
                for(auto pp : cps)
                    if(bsum == (((ss * ss) / 4 - 1) - pp.second) / (int)pp.first.size())
                    {
                        coupe = pp.first;
                        break;
                    }
                for(auto p : coupe)
                {
                    case_type cible = (case_type)6;
                    bool alone = false;
                    while(!alone)
                    {
                        cible = (case_type)((int)cible - 1);
                        alone = true;
                        FOR(i, 4)
                        {
                            position nouv = {p.ligne + dir[i][0], p.colonne + dir[i][1]};
                            if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                                if(type_case(nouv, joueurs[ADV]) == cible)
                                    alone = false;
                        }
                    }

                    catalyser(p, joueurs[ADV], cible); // TODO : choose worst catalyser (or even metal)
                    ++nbA;
                    --nbC;
                }
            }
            update_grille(ADV);
        }
    }
    if(!tempo)
        update_grille(MOI);
    return nbA;
}

void transmute()
{
    int maxi = -42;
    position real = {-1, -1};
    GRILLE(i, j)
    {
        if(grilles[MOI][i][j] != VIDE)
        {
            int gain = quantite_transmutation({i, j}, MOI);
            if(grilles[MOI][i][j] != VIDE && gain > maxi)
            {
                maxi = gain;
                real = {i, j};
            }
        }
    }
    transmute(real);
    update_grille(MOI);
}

bool est_met(position pos, int id)
{
    switch(grilles[id][pos.ligne][pos.colonne])
    {
        case PLOMB:
        case FER:
        case CUIVRE:
            return 1;
            break;
        default:
            return 0;
            break;
    }
}

bool est_cat(position pos, int id)
{
    switch(grilles[id][pos.ligne][pos.colonne])
    {
        case SOUFRE:
        case MERCURE:
            return 1;
            break;
        default:
            return 0;
            break;
    }
}

int taille(position pos, int id)
{
    bool innerDejaVu[TAILLE_ETABLI][TAILLE_ETABLI];
    int rep = 0;
    queue<position> file;
    file.push(pos);
    GRILLE(i, j)
        innerDejaVu[i][j] = 0;
    while(file.size())
    {
        position cur = file.front();
        file.pop();
        if(!innerDejaVu[cur.ligne][cur.colonne])
        {
            ++rep;
            innerDejaVu[cur.ligne][cur.colonne] = true;
            FOR(i, 4)
            {
                position nouv = {cur.ligne + dir[i][0], cur.colonne + dir[i][1]};
                if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                    if(grilles[id][nouv.ligne][nouv.colonne] == grilles[id][pos.ligne][pos.colonne])
                        file.push(nouv);
            }
        }
    }
    return rep;
}

int libertes(position pos, int id)
{
    int rep = 0;
    queue<position> file;
    file.push(pos);
    GRILLE(i, j)
        dejaVu[i][j] = 0;
    while(file.size())
    {
        position cur = file.front();
        file.pop();
        if(!dejaVu[cur.ligne][cur.colonne])
        {
            //if(tour_actuel() == 1)
            //    printf("%d %d %d\n", cur.ligne, cur.colonne, (int)grilles[id][cur.ligne][cur.colonne]);
            dejaVu[cur.ligne][cur.colonne] = true;
            FOR(i, 4)
            {
                position nouv = {cur.ligne + dir[i][0], cur.colonne + dir[i][1]};
                if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                {
                    if(grilles[id][nouv.ligne][nouv.colonne] == grilles[id][pos.ligne][pos.colonne])
                        file.push(nouv);
                    else if(grilles[id][nouv.ligne][nouv.colonne] == VIDE)
                    {
                        if(!dejaVu[nouv.ligne][nouv.colonne])
                        {
                            bool seul = true;
                            FOR(j, 4)
                            {
                                position nnouv = {nouv.ligne + dir[j][0], nouv.colonne + dir[j][1]};
                                if(grilles[id][nnouv.ligne][nnouv.colonne] == VIDE)
                                    seul = false;
                            }
                            if(!seul)
                                ++rep;
                        }
                        dejaVu[nouv.ligne][nouv.colonne] = true;
                    }
                }
            }
        }
    }
    //if(tour_actuel() == 1)
    //    printf("%d %d %d %d\n", pos.ligne, pos.colonne, (int)grilles[id][pos.ligne][pos.colonne], rep);
    return rep * (est_met(pos, id) ? 1 : 0);
}

int centralite(position pos, int id)
{
    int rep = 0;

    GRILLE2(i, j, p)
        if(grilles[id][i][j] == grilles[id][pos.ligne][pos.colonne])
        {
            //rep += abs(i - pos.ligne) + abs(j - pos.colonne); // Distance Manhattan
            rep += (int)sqrt((i - pos.ligne) * (i - pos.ligne) + (j - pos.colonne) * (j - pos.colonne)); // Distance Euclidienne
        }


    return rep;
}

int centralite_vide(position pos, int id)
{
    int rep = 0;

    GRILLE2(i, j, p)
        if(grilles[id][i][j] == VIDE)
        {
            rep += abs(i - pos.ligne) + abs(j - pos.colonne); // Distance Manhattan
            //rep += max(abs(i - pos.ligne), abs(j - pos.colonne)); // Distance loo
            //rep += (int)sqrt((i - pos.ligne) * (i - pos.ligne) + (j - pos.colonne) * (j - pos.colonne)); // Distance Euclidienne
        }


    return rep;
}

int isolement(position pos, int id)
{
    int rep = 0;

    GRILLE2(i, j, p)
        if(grilles[id][i][j] != grilles[id][pos.ligne][pos.colonne])
        {
            //rep += abs(i - pos.ligne) + abs(j - pos.colonne); // Distance Manhattan
            rep += max(abs(i - pos.ligne), abs(j - pos.colonne)); // Distance loo
            //rep += (int)sqrt((i - pos.ligne) * (i - pos.ligne) + (j - pos.colonne) * (j - pos.colonne)); // Distance Euclidienne
        }


    return rep;
}

void choisir(vector<position_echantillon>& coups, int id)
{
    assert(coups.size());
    position_echantillon best = coups[0];
    int score = -oo;

    for(auto ech : coups)
    {
        placer_echantillon(ech.pos1, ech.pos2);
        update_grille(id);

        int sz1 = taille(ech.pos1, id);
        int sz2 = taille(ech.pos2, id);
        int siz = sz1 * sz1 + sz2 * sz2;
        int lib = libertes(ech.pos1, id) + libertes(ech.pos2, id);
        int cen = centralite(ech.pos1, id) + centralite(ech.pos2, id);
        int cev = centralite_vide(ech.pos1, id) + centralite_vide(ech.pos2, id);
        int iso = isolement(ech.pos1, id) + isolement(ech.pos2, id);
        //printf("%d %d %d\n", ech.pos1.ligne, ech.pos1.colonne, cev);

        int val = 60 * siz + 10 * (2 * lib - cen - 2 * cev) + iso;
        if(val > score)
        {
            score = val;
            best = ech;
        }
        annuler();
    }
    //printf(" %d %d %d\n", best.pos1.ligne, best.pos1.colonne, score);

    placer_echantillon(best.pos1, best.pos2);
    update_grille(MOI);
}

vector<pair<vector<position>, int> > coupes(position pos, int id, int maxi, int last)
{
    vector<pair<vector<position>, int> > ret;
    {
        case_type tp = grilles[id][pos.ligne][pos.colonne];
        int sz = taille(pos, id);
        queue<position> file;
        file.push(pos);
        GRILLE(i, j)
            dejaVu[i][j] = 0;
        dejaVu[pos.ligne][pos.colonne] = true;
        while(file.size())
        {
            position cur = file.front();
            file.pop();
            //printf("%d %d %d\n", (int)file.size(), pos.ligne, pos.colonne);
            grilles[id][cur.ligne][cur.colonne] = VIDE;
            int sum = 0;
            int ss = 0;

            FOR(i, 4)
            {
                position nouv = {cur.ligne + dir[i][0], cur.colonne + dir[i][1]};
                if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                    if(!dejaVu[nouv.ligne][nouv.colonne] && grilles[id][nouv.ligne][nouv.colonne] == tp)
                    {
                        //printf("%d %d -> %d %d %d\n", cur.ligne, cur.colonne, nouv.ligne, nouv.colonne, (int)dejaVu[nouv.ligne][nouv.colonne]);
                        dejaVu[nouv.ligne][nouv.colonne] = true;
                        file.push(nouv);

                        int ss2 = taille(nouv, id);
                        ss = max(ss, ss2);
                        sum += ss2*ss2 / 4 - 1;
                    }
            }
            if(cur.ligne * TAILLE_ETABLI + cur.colonne > last && ss != sz-1)
                ret.push_back({{cur}, sum});
            grilles[id][cur.ligne][cur.colonne] = tp;
        }
    }
    if(maxi > 1)
    {
        bool innerDejaVu[TAILLE_ETABLI][TAILLE_ETABLI];
        GRILLE(i, j)
            innerDejaVu[i][j] = 0;
        case_type tp = grilles[id][pos.ligne][pos.colonne];
        queue<position> file;
        file.push(pos);
        GRILLE(i, j)
            innerDejaVu[i][j] = 0;
        while(file.size())
        {
            position cur = file.front();
            file.pop();
            if(!innerDejaVu[cur.ligne][cur.colonne])
            {
                // TODO
                grilles[id][cur.ligne][cur.colonne] = VIDE;
                position vois = {-1, -1};

                innerDejaVu[cur.ligne][cur.colonne] = true;
                FOR(i, 4)
                {
                    position nouv = {cur.ligne + dir[i][0], cur.colonne + dir[i][1]};
                    if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                        if(grilles[id][nouv.ligne][nouv.colonne] == tp)
                        {
                            file.push(nouv);
                            vois = nouv;
                        }
                }
                if(vois.ligne != -1 && cur.ligne * TAILLE_ETABLI + cur.colonne > last)
                {
                    vector<pair<vector<position>, int> > rr = coupes(vois, id, maxi-1, cur.ligne * TAILLE_ETABLI + cur.colonne);
                    for(auto p : rr)
                    {
                        p.first.push_back(cur);
                        ret.push_back(p);
                    }
                }
                grilles[id][cur.ligne][cur.colonne] = tp;
            }
            return ret;
        }
    }
    return ret;
}

void marquer(position pos, int id)
{
    queue<position> file;
    file.push(pos);
    while(file.size())
    {
        position cur = file.front();
        file.pop();
        if(!dejaVu[cur.ligne][cur.colonne])
        {
            dejaVu[cur.ligne][cur.colonne] = true;
            FOR(i, 4)
            {
                position nouv = {cur.ligne + dir[i][0], cur.colonne + dir[i][1]};
                if(nouv.ligne >= 0 && nouv.ligne < TAILLE_ETABLI && nouv.colonne >= 0 && nouv.colonne < TAILLE_ETABLI)
                    if(grilles[id][nouv.ligne][nouv.colonne] == grilles[id][pos.ligne][pos.colonne])
                        file.push(nouv);
            }
        }
    }
}





